/**
 * @name array-of-arrays-sort-by-col
 * @fileoverview Sort array of arrays by column, rippling the sorting outwards from that column
 * @version 4.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-sort-by-col/}
 */

var arrayOfArraysSortByCol=(()=>{var i=Object.defineProperty;var g=Object.getOwnPropertyDescriptor;var m=Object.getOwnPropertyNames;var $=Object.prototype.hasOwnProperty;var f=o=>i(o,"__esModule",{value:!0});var p=(o,e)=>{for(var u in e)i(o,u,{get:e[u],enumerable:!0})},b=(o,e,u,l)=>{if(e&&typeof e=="object"||typeof e=="function")for(let r of m(e))!$.call(o,r)&&(u||r!=="default")&&i(o,r,{get:()=>e[r],enumerable:!(l=g(e,r))||l.enumerable});return o};var d=(o=>(e,u)=>o&&o.get(e)||(u=b(f({}),e,1),o&&o.set(e,u),u))(typeof WeakMap!="undefined"?new WeakMap:0);var D={};p(D,{sortByCol:()=>S,version:()=>h});var c="4.0.11";var h=c;function s(o){return o!=null}function S(o,e=0){if(!Array.isArray(o))throw new Error(`array-of-arrays-sort-by-col: [THROW_ID_01]: The first input argument was given not as array but as ${typeof o}, equal to:
${JSON.stringify(o,null,0)}`);if(isNaN(+e))throw new Error(`array-of-arrays-sort-by-col: [THROW_ID_02]: The second input argument, index of the column to sort by (axis), is not integer (incl. zero)! It's currently given as:
${JSON.stringify(e,null,0)} (type ${typeof e})`);let u=Math.max(...o.map(r=>r.length));if(!u)return o;if(+e>=u)throw new Error(`array-of-arrays-sort-by-col: [THROW_ID_03]: The second input argument, index of the column to sort by (axis), is marking the column which does not exist on any of the input arrays. Axis was given as ${+e} while highest index goes as far as ${u}.`);return Array.from(o).sort((r,n)=>{if(r[+e]!==n[+e]){if(!s(r[+e])&&s(n[+e])||s(r[+e])&&s(n[+e])&&r[+e]>n[+e])return 1;if(s(r[+e])&&!s(n[+e])||s(r[+e])&&s(n[+e])&&r[+e]<n[+e])return-1}let a=Math.max(r.length,n.length),y=Math.max(+e,a-+e-1);for(let t=1;t<=y;t++){if(+e-t>=0){if(s(r[+e-t]))if(s(n[+e-t])){if(r[+e-t]<n[+e-t])return-1;if(r[+e-t]>n[+e-t])return 1}else return-1;else if(s(n[+e-t]))return 1}if(+e+t<a){if(s(r[+e+t]))if(s(n[+e+t])){if(r[+e+t]<n[+e+t])return-1;if(r[+e+t]>n[+e+t])return 1}else return-1;else if(s(n[+e+t]))return 1}}return 0})}return d(D);})();
